

import javax.microedition.lcdui.*;

public class ConfigCanvas extends Canvas {
		public mainroutines mr;
		public boolean detailSelected=false;
		public int index=-1, indexdebut=-1, indexfin=-1;
		private Image imgar;
		private int width, height;

//	-----------------------------------------------------------------------------
		public ConfigCanvas(mainroutines mrh ) {
			mr=mrh;
			width = getWidth ();
			height = getHeight ();
	    // Construct the image from the media file
		    try {
		    	imgar = Image.createImage("/res/mosque-ar32.png");
		    } catch (Exception e) {
		      e.printStackTrace ();
		      imgar = null;
		    }
		  }

//		-----------------------------------------------------------------------------
//		 Paint the screen based on the name
			protected void paint (Graphics g) {
				int lyyy, ligne, delta, i, j;
				g.setColor(0xffffff);
				g.fillRect(0,  0, width, height);
				g.setColor(0x000000);

				if (imgar != null) g.drawImage (imgar, width, 0, Graphics.TOP | Graphics.RIGHT);
				if (!detailSelected )
				{	// affiche la liste des villes pour le choix
				g.setFont(Font.getFont( Font.FACE_PROPORTIONAL, Font.STYLE_PLAIN, Font.SIZE_SMALL));
				lyyy=g.getFont().getHeight()-2;
				delta=height/lyyy-2;
				g.setColor(0x0066CC);
				indexdebut=index-delta/2; indexfin=index+delta/2;
				if (indexdebut<0)		{
										indexdebut=0; indexfin=delta;
										if (indexfin>mr.NTowns) 	indexfin=mr.NTowns;
										}
				if (indexfin>mr.NTowns)	{
										indexdebut=mr.NTowns-delta; indexfin=mr.NTowns;
										if (indexdebut<0) 	indexdebut=0;
										}
				for (i=indexdebut, j=0; i<indexfin; i++, j++)
					{
					if(i==index){
			                    g.setColor(0x00FF00);
			                    g.drawString (mr.Countries[ mr.Towns[i].Country ].CountryName+", "+ mr.Towns[i].TownName,
										2, (j+1)*(lyyy+2), Graphics.BASELINE | Graphics.LEFT);
			                    g.setColor(0x0066CC);
								}
						else	g.drawString (mr.Countries[ mr.Towns[i].Country ].CountryName+", "+ mr.Towns[i].TownName,
												2, (j+1)*(lyyy+2), Graphics.BASELINE | Graphics.LEFT);
					}

				}
				if (detailSelected )
					{	// affiche la liste des villes pour le choix
					int indexedCountry=mr.Towns[index].Country, 
						indexedConvention=mr.Countries[indexedCountry].Convention;
					g.setFont(Font.getFont( Font.FACE_PROPORTIONAL, Font.STYLE_PLAIN, Font.SIZE_SMALL));
					lyyy=g.getFont().getHeight()-2;
					g.setColor(0x000000);
					ligne=lyyy+2;
					g.drawString ("Dtails sur :",
							2, ligne, Graphics.BASELINE | Graphics.LEFT);
					g.setColor(0x00FF00);
					ligne+=lyyy;
                    g.drawString (mr.Towns[index].TownName,
							2, ligne, Graphics.BASELINE | Graphics.LEFT);
					g.setColor(0xFF0000);
					ligne+=lyyy;
                    g.drawString ("Pays : "+mr.Countries[indexedCountry].CountryName,
							2, ligne, Graphics.BASELINE | Graphics.LEFT);
                    g.setColor(0x0000FF);
					ligne+=lyyy;
					g.drawString ("Latitude : "+mr.Towns[index].latitude+"",
    						2, ligne, Graphics.BASELINE | Graphics.LEFT);
					ligne+=lyyy;
					g.drawString ("Longitude : "+mr.Towns[index].longitude+"",
    						2, ligne, Graphics.BASELINE | Graphics.LEFT);
					ligne+=lyyy;
					g.drawString ("Time zone : "+mr.Countries[indexedCountry].TimeZoneTown,
							2, ligne, Graphics.BASELINE | Graphics.LEFT);
					ligne+=lyyy;
					g.drawString ("Daylight Saving Time : "+mr.Countries[indexedCountry].DST,
							2, ligne, Graphics.BASELINE | Graphics.LEFT);
					g.setColor(0x0066CC);
					ligne+=lyyy;
	                g.drawString ("Convention : "+indexedConvention + " "+mr.SalatTimeConfig[indexedConvention].name,
	   						2, ligne, Graphics.BASELINE | Graphics.LEFT);

					ligne+=lyyy;
	                g.drawString ((mr.SalatTimeConfig[indexedConvention].AsrShafi ==1)? "Asr Shafi": "Asr Hanafi",
							2, ligne, Graphics.BASELINE | Graphics.LEFT);
					if (mr.SalatTimeConfig[indexedConvention].ZuhrFixe ==1)
							{
							ligne+=lyyy;
							g.drawString ("Zhur fixe  "+mr.h2hmiarrondie(mr.SalatTimeConfig[indexedConvention].ZuhrFixeHour),
										2, ligne, Graphics.BASELINE | Graphics.LEFT);
							}
					if (mr.SalatTimeConfig[indexedConvention].Isha_is_Maghrib_plus ==1) 
							{
							ligne+=lyyy;
							g.drawString ( "Isha=Maghrib + "+mr.SalatTimeConfig[indexedConvention].Isha_is_Maghrib_plus_min+ "min",
										2, ligne, Graphics.BASELINE | Graphics.LEFT);
							}
					ligne+=lyyy;
	                g.drawString ( "Fajr twilight angle : "+mr.SalatTimeConfig[indexedConvention].FajrTwilightAngle+ "",
	   						2, ligne, Graphics.BASELINE | Graphics.LEFT);
					ligne+=lyyy;
	                g.drawString ( "Isha twilight angle : "+mr.SalatTimeConfig[indexedConvention].IshaTwilightAngle+ "",
	   						2, ligne, Graphics.BASELINE | Graphics.LEFT);

//echo "<div style='text-align: left;'> <table cellpadding=0 cellspacing=1 border=1 class=tb> 
//			<tr bgcolor=\"#00F0B0\">
//			<td width=10><b> Convention </b></td> 
//			<td width=40><b> Fajr Twilight Angle </b></td>
//			<td width=40><b> Isha Twilight Angle </b></td>
//			<td width=40><b> Sunrise / set Angle </b></td>
//			<td width=40><b> Adjust Fajr </b></td>
//			<td width=40><b> Adjust Chourouk</b></td>
//			<td width=40><b> Adjust Zuhr </b></td>
//			<td width=40><b> Adjust Asr </b></td>
//			<td width=40><b> Adjust Maghrib </b></td>
//			<td width=40><b> Adjust Isha</b></td> </tr>";
//printf("
//			<td width=10 align=\"right\">%1d</td> 
//			<td width=40>&nbsp;%s</td> 
//			<td width=40>&nbsp;%s</td>
//			<td width=40>&nbsp;%s</td>
//			<td width=40>&nbsp;%s</td>
//			<td width=45>&nbsp;%d min</td>
//			<td width=40>&nbsp;%s </td>
//			<td width=40>&nbsp;%s </td>
//			<td width=40>&nbsp;%s </td>
//			<td width=45>&nbsp;%d min</td>
//			<td width=40>&nbsp;%d min</td>
//			<td width=40>&nbsp;%d min</td>
//			<td width=40>&nbsp;%d min</td>
//			<td width=40>&nbsp;%d min</td>
//			<td width=40>&nbsp;%d min</td></tr>\n",
Convention, ($SalatTimeConfig[$Convention]->AsrShafi ? "Yes":"No"),
//			($SalatTimeConfig[$Convention]->ZuhrFixe ? "Yes":"No"), h2hmin( $SalatTimeConfig[$Convention]->ZuhrFixeHour),
//			($SalatTimeConfig[$Convention]->Isha_is_Maghrib_plus ? "Yes":"No"), $SalatTimeConfig[$Convention]->Isha_is_Maghrib_plus_min,
SalatTimeConfig[$Convention]->FajrTwilightAngle, $SalatTimeConfig[$Convention]->IshaTwilightAngle,
SalatTimeConfig[$Convention]->Sunrise_setAngle,
SalatTimeConfig[$Convention]->SalatTimeAdjust->Fajr, $SalatTimeConfig[$Convention]->SalatTimeAdjust->Chourouk,
SalatTimeConfig[$Convention]->SalatTimeAdjust->Zuhr, $SalatTimeConfig[$Convention]->SalatTimeAdjust->Asr,
SalatTimeConfig[$Convention]->SalatTimeAdjust->Maghrib, $SalatTimeConfig[$Convention]->SalatTimeAdjust->Isha);
//echo "</table></div>";

	                detailSelected=false;
			    	}
			}
//		-----------------------------------------------------------------------------
		    public void keyPressed(int key){
		        switch(key){
		            case -1:
		                index = (index > 0)? index-1:index;
		                System.out.println("___appui sur key -1=");
		                break;
		            case -2:
		                index = (index < mr.NTowns-1)? index+1:index;
		                System.out.println("___appui sur key -2___");
		                break;
		            case -5: // valide le choix
		                System.out.println("___appui sur key___");
		                if (index==-1)	 // choix non ralis
								          {
									        System.out.println("___choix non ralis___");
							            }
										else	{
													System.out.println("___choix ralis___");
													detailSelected=true;
													}
		                break;
//		            case -6: // valide le choix
//		                System.out.println("___appui sur key___");
//		                if (index==-1)	 // choix non ralis
//								          {
//									        System.out.println("___choix non ralis___");
//							            }
//										else	{
//													System.out.println("___choix ralis___");
//													mr.TownSelected=index;
//													configSelected=false;
//													}
//		                break;

		        }
				repaint();
		    }
//		  -----------------------------------------------------------------------------
			public void keyRepeated(int key){
		    	switch(key){
		            case -1:
		                index-=5;
		                if (index < 0)	index=0;
		                //System.out.println("___appui prolong sur key -1=");
		                break;
		            case -2:
		                index+=5;
		                if (index > mr.NTowns-1)	index=mr.NTowns-1;
		                //System.out.println("___appui prolongsur key -2___");
		                break;
				}
			    repaint();
			}
//		-----------------------------------------------------------------------------
}
