
import javax.microedition.lcdui.*;

public class ConfigSCanvas extends Canvas {
		public mainroutines mr;
		public boolean detailSelected=false;
		public int indexdebut=-1, indexfin=-1;
		public int indexpays=0;	
		public int indexville=0;
		public int viewmode=1;	//1:pays, 2: ville, 3:dtails
		private Image imgar;
		private int width, height, width_2;

//	-----------------------------------------------------------------------------
		public ConfigSCanvas(mainroutines mrh ) {
			mr=mrh;
			width = getWidth ();
			width_2=width /2;
			height = getHeight ();
	    // Construct the image from the media file
		    try {
		    	imgar = Image.createImage("/res/mosque-ar32.png");
		    } catch (Exception e) {
		      e.printStackTrace ();
		      imgar = null;
		    }
		  }

//		-----------------------------------------------------------------------------
//		 Paint the screen based on the name
		protected void paint (Graphics g) {
			int lyyy, ligne, delta, i, j;
			g.setColor(0xffffff);
			g.fillRect(0,  0, width, height);
			g.setColor(0x000000);

			if (imgar != null) g.drawImage (imgar, width, 0, Graphics.TOP | Graphics.RIGHT);
			if (!detailSelected)  	
			{	// affiche la liste des PAYS pour le choix
			if (viewmode==1)	// affichage des Pays pour selection
				{	
				g.setFont(Font.getFont( Font.FACE_PROPORTIONAL, Font.STYLE_PLAIN, Font.SIZE_SMALL));
				lyyy=g.getFont().getHeight()-2;
				delta=height/lyyy-2;
				g.setColor(0x0066CC);
				indexdebut=indexpays-delta/2; indexfin=indexpays+delta/2;
				if (indexdebut<0)		{
										indexdebut=0; indexfin=delta;
										if (indexfin>mainroutines.NCountries) 	indexfin=mainroutines.NCountries;
										}
				if (indexfin>mainroutines.NCountries)	{
										indexdebut=mainroutines.NCountries-delta; indexfin=mainroutines.NCountries;
										if (indexdebut<0) 	indexdebut=0;
										}
				for (i=indexdebut, j=0; i<indexfin; i++, j++)
					{
					if(i==indexpays){
			                    g.setColor(0x00FF00);
			                    g.drawString (mr.Countries[i].CountryName,
										2, (j+1)*(lyyy+2), Graphics.BASELINE | Graphics.LEFT);
			                    g.setColor(0x0066CC);
								}
						else	g.drawString (mr.Countries[i].CountryName,
										2, (j+1)*(lyyy+2), Graphics.BASELINE | Graphics.LEFT);
					}

				}
			// choix de la ville
			if (viewmode==2)	// affiche la liste des villes pour le choix
				{	
				g.setFont(Font.getFont( Font.FACE_PROPORTIONAL, Font.STYLE_PLAIN, Font.SIZE_SMALL));
				lyyy=g.getFont().getHeight()-2;
				delta=height/lyyy-2;
				g.setColor(0x0066CC);
				indexdebut=indexville-delta/2; indexfin=indexville+delta/2;
				if (indexdebut<mr.Countries[indexpays].debut)		{
										indexdebut=mr.Countries[indexpays].debut; indexfin=mr.Countries[indexpays].debut+delta;
										if (indexfin>mr.Countries[indexpays].fin) 	indexfin=mr.Countries[indexpays].fin;
										}
				if (indexfin>mr.Countries[indexpays].fin)	{
										indexdebut=mr.Countries[indexpays].fin-delta; indexfin=mr.Countries[indexpays].fin;
										if (indexdebut<mr.Countries[indexpays].debut) 	indexdebut=mr.Countries[indexpays].debut;
										}
				for (i=indexdebut, j=0; i<indexfin; i++, j++)
					{
					if(i==indexville){
			                    g.setColor(0x00FF00);
			                    g.drawString (mr.Countries[ mr.Towns[i].Country ].CountryName+", "+ mr.Towns[i].TownName,
										2, (j+1)*(lyyy+2), Graphics.BASELINE | Graphics.LEFT);
			                    g.setColor(0x0066CC);
								}
						else	g.drawString (mr.Countries[ mr.Towns[i].Country ].CountryName+", "+ mr.Towns[i].TownName,
												2, (j+1)*(lyyy+2), Graphics.BASELINE | Graphics.LEFT);
					}

				}
			}
			if (detailSelected && viewmode==2)
					{	// affiche la liste des villes pour le choix
					int indexedCountry=mr.Towns[indexville].Country, 
						indexedConvention=mr.Countries[indexedCountry].Convention;
					g.setFont(Font.getFont( Font.FACE_PROPORTIONAL, Font.STYLE_PLAIN, Font.SIZE_SMALL));
					lyyy=g.getFont().getHeight()-2;
					g.setColor(0x000000);
					ligne=lyyy+2;
					g.drawString ("Dtails sur :",
							2, ligne, Graphics.BASELINE | Graphics.LEFT);
					g.setColor(0x00FF00);
					ligne+=lyyy;
                    g.drawString (mr.Towns[indexville].TownName,
							2, ligne, Graphics.BASELINE | Graphics.LEFT);
					g.setColor(0xFF0000);
					ligne+=lyyy;
                    g.drawString ("Pays : "+mr.Countries[indexedCountry].CountryName,
							2, ligne, Graphics.BASELINE | Graphics.LEFT);
                    g.setColor(0x0000FF);
					ligne+=lyyy;
					g.drawString ("Latitude : "+mr.Towns[indexville].latitude+"",
    						2, ligne, Graphics.BASELINE | Graphics.LEFT);
					ligne+=lyyy;
					g.drawString ("Longitude : "+mr.Towns[indexville].longitude+"",
    						2, ligne, Graphics.BASELINE | Graphics.LEFT);
					ligne+=lyyy;
					g.drawString ("Time zone : "+mr.Countries[indexedCountry].TimeZoneTown,
							2, ligne, Graphics.BASELINE | Graphics.LEFT);
					ligne+=lyyy;
					g.drawString ("Daylight Saving Time : "+mr.Countries[indexedCountry].DST,
							2, ligne, Graphics.BASELINE | Graphics.LEFT);
					g.setColor(0x0066CC);
					ligne+=lyyy;
	                g.drawString ("Convention : "+indexedConvention + " "+mr.SalatTimeConfig[indexedConvention].name,
	   						2, ligne, Graphics.BASELINE | Graphics.LEFT);

					ligne+=lyyy;
	                g.drawString ((mr.SalatTimeConfig[indexedConvention].AsrShafi ==1)? "Asr Shafi": "Asr Hanafi",
							2, ligne, Graphics.BASELINE | Graphics.LEFT);
					if (mr.SalatTimeConfig[indexedConvention].ZuhrFixe ==1)
							{
							ligne+=lyyy;
							g.drawString ("Zhur fixe  "+mr.h2hmiarrondie(mr.SalatTimeConfig[indexedConvention].ZuhrFixeHour),
										2, ligne, Graphics.BASELINE | Graphics.LEFT);
							}
					if (mr.SalatTimeConfig[indexedConvention].Isha_is_Maghrib_plus ==1) 
							{
							ligne+=lyyy;
							g.drawString ( "Isha=Maghrib + "+mr.SalatTimeConfig[indexedConvention].Isha_is_Maghrib_plus_min+ "min",
										2, ligne, Graphics.BASELINE | Graphics.LEFT);
							}
					ligne+=lyyy;
	                g.drawString ( "Fajr twilight angle : "+mr.SalatTimeConfig[indexedConvention].FajrTwilightAngle+ "",
	   						2, ligne, Graphics.BASELINE | Graphics.LEFT);
					ligne+=lyyy;
	                g.drawString ( "Isha twilight angle : "+mr.SalatTimeConfig[indexedConvention].IshaTwilightAngle+ "",
	   						2, ligne, Graphics.BASELINE | Graphics.LEFT);
			    	}
			if (detailSelected && viewmode==1)
			{	// affiche les infos sur le pays en question
			int indexedConvention=mr.Countries[indexpays].Convention;
			g.setFont(Font.getFont( Font.FACE_PROPORTIONAL, Font.STYLE_PLAIN, Font.SIZE_SMALL));
			lyyy=g.getFont().getHeight()-2;
			g.setColor(0x000000);
			ligne=lyyy+2;
			g.drawString ("Dtails sur :",
					2, ligne, Graphics.BASELINE | Graphics.LEFT);
			g.setColor(0x00FF00);
			ligne+=lyyy;
            g.drawString ("Pays : "+mr.Countries[indexpays].CountryName,
					2, ligne, Graphics.BASELINE | Graphics.LEFT);
            g.setColor(0x0000FF);
			ligne+=lyyy;
			g.drawString ("Time zone : "+mr.Countries[indexpays].TimeZoneTown,
					2, ligne, Graphics.BASELINE | Graphics.LEFT);
			ligne+=lyyy;
			g.drawString ("Daylight Saving Time : "+mr.Countries[indexpays].DST,
					2, ligne, Graphics.BASELINE | Graphics.LEFT);
			g.setColor(0x0066CC);
			ligne+=lyyy;
            g.drawString ("Convention : "+indexedConvention + " "+mr.SalatTimeConfig[indexedConvention].name,
						2, ligne, Graphics.BASELINE | Graphics.LEFT);

			ligne+=lyyy;
            g.drawString ((mr.SalatTimeConfig[indexedConvention].AsrShafi ==1)? "Asr Shafi": "Asr Hanafi",
					2, ligne, Graphics.BASELINE | Graphics.LEFT);
			if (mr.SalatTimeConfig[indexedConvention].ZuhrFixe ==1)
					{
					ligne+=lyyy;
					g.drawString ("Zhur fixe  "+mr.h2hmiarrondie(mr.SalatTimeConfig[indexedConvention].ZuhrFixeHour),
								2, ligne, Graphics.BASELINE | Graphics.LEFT);
					}
			if (mr.SalatTimeConfig[indexedConvention].Isha_is_Maghrib_plus ==1) 
					{
					ligne+=lyyy;
					g.drawString ( "Isha=Maghrib + "+mr.SalatTimeConfig[indexedConvention].Isha_is_Maghrib_plus_min+ "min",
								2, ligne, Graphics.BASELINE | Graphics.LEFT);
					}
			ligne+=lyyy;
            g.drawString ( "Fajr twilight angle : "+mr.SalatTimeConfig[indexedConvention].FajrTwilightAngle+ "",
						2, ligne, Graphics.BASELINE | Graphics.LEFT);
			ligne+=lyyy;
            g.drawString ( "Isha twilight angle : "+mr.SalatTimeConfig[indexedConvention].IshaTwilightAngle+ "",
						2, ligne, Graphics.BASELINE | Graphics.LEFT);
			ligne+=lyyy;
            g.drawString ( "Adjust : ", 2, ligne, Graphics.BASELINE | Graphics.LEFT);
			ligne+=lyyy;
            g.drawString ( "Fajr : "+mr.SalatTimeConfig[indexedConvention].SalatTimeAdjust.Fajr+ " '",
						10, ligne, Graphics.BASELINE | Graphics.LEFT);
            g.drawString ( "Chourouk : "+mr.SalatTimeConfig[indexedConvention].SalatTimeAdjust.Chourouk+ " '",
						width_2, ligne, Graphics.BASELINE | Graphics.LEFT);
			ligne+=lyyy;
            g.drawString ( "Zuhr : "+mr.SalatTimeConfig[indexedConvention].SalatTimeAdjust.Zuhr+ " '",
            			10, ligne, Graphics.BASELINE | Graphics.LEFT);
            g.drawString ( "Asr : "+mr.SalatTimeConfig[indexedConvention].SalatTimeAdjust.Asr+ " '",
            			width_2, ligne, Graphics.BASELINE | Graphics.LEFT);
			ligne+=lyyy;
            g.drawString ( "Maghrib : "+mr.SalatTimeConfig[indexedConvention].SalatTimeAdjust.Maghrib+ " '",
            			10, ligne, Graphics.BASELINE | Graphics.LEFT);
            g.drawString ( "Isha : "+mr.SalatTimeConfig[indexedConvention].SalatTimeAdjust.Isha+ " '",
            			width_2, ligne, Graphics.BASELINE | Graphics.LEFT);

//echo "<div style='text-align: left;'> <table cellpadding=0 cellspacing=1 border=1 class=tb> 
//	<tr bgcolor=\"#00F0B0\">
//	<td width=10><b> Convention </b></td> 
//	<td width=40><b> Fajr Twilight Angle </b></td>
//	<td width=40><b> Isha Twilight Angle </b></td>
//	<td width=40><b> Sunrise / set Angle </b></td>
//	<td width=40><b> Adjust Fajr </b></td>
//	<td width=40><b> Adjust Chourouk</b></td>
//	<td width=40><b> Adjust Zuhr </b></td>
//	<td width=40><b> Adjust Asr </b></td>
//	<td width=40><b> Adjust Maghrib </b></td>
//	<td width=40><b> Adjust Isha</b></td> </tr>";
//printf("
//	<td width=10 align=\"right\">%1d</td> 
//	<td width=40>&nbsp;%s</td> 
//	<td width=40>&nbsp;%s</td>
//	<td width=40>&nbsp;%s</td>
//	<td width=40>&nbsp;%s</td>
//	<td width=45>&nbsp;%d min</td>
//	<td width=40>&nbsp;%s </td>
//	<td width=40>&nbsp;%s </td>
//	<td width=40>&nbsp;%s </td>
//	<td width=45>&nbsp;%d min</td>
//	<td width=40>&nbsp;%d min</td>
//	<td width=40>&nbsp;%d min</td>
//	<td width=40>&nbsp;%d min</td>
//	<td width=40>&nbsp;%d min</td>
//	<td width=40>&nbsp;%d min</td></tr>\n",
//	$Convention, ($SalatTimeConfig[$Convention]->AsrShafi ? "Yes":"No"),
//	($SalatTimeConfig[$Convention]->ZuhrFixe ? "Yes":"No"), h2hmin( $SalatTimeConfig[$Convention]->ZuhrFixeHour),
//	($SalatTimeConfig[$Convention]->Isha_is_Maghrib_plus ? "Yes":"No"), $SalatTimeConfig[$Convention]->Isha_is_Maghrib_plus_min,
//	$SalatTimeConfig[$Convention]->FajrTwilightAngle, $SalatTimeConfig[$Convention]->IshaTwilightAngle,
//	$SalatTimeConfig[$Convention]->Sunrise_setAngle,
//	$SalatTimeConfig[$Convention]->SalatTimeAdjust->Fajr, $SalatTimeConfig[$Convention]->SalatTimeAdjust->Chourouk,
//	$SalatTimeConfig[$Convention]->SalatTimeAdjust->Zuhr, $SalatTimeConfig[$Convention]->SalatTimeAdjust->Asr,
//	$SalatTimeConfig[$Convention]->SalatTimeAdjust->Maghrib, $SalatTimeConfig[$Convention]->SalatTimeAdjust->Isha);
//echo "</table></div>";
	    	}
	}
//-----------------------------------------------------------------------------
	public void keyPressed(int key){
			detailSelected=false;
			if (viewmode==1)	// on deroule la liste des Pays 
				{
		        switch(key){
		            case -1:
		                indexpays = (indexpays > 0)? indexpays-1:indexpays;
		                System.out.println("___Pays appui sur key -1=");
		                break;
		            case -2:
		            	indexpays = (indexpays < mainroutines.NCountries-1)? indexpays+1:indexpays;
		                System.out.println("___Pays appui sur key -2___");
		                break;
		            case -5: // valide le choix
		                System.out.println("_Pays appui sur key Entre___");
		                if (indexpays==-1)	 // choix non ralis
								          {
									        System.out.println("___choix non ralis___");
							            }
										else	{
													System.out.println("___choix ralis___");
													detailSelected=true;
													}
		                break;
	        		}
				}
			if (viewmode==2)	// on deroule la liste des villes
				{
		        switch(key){
		            case -1:
		                indexville = (indexville > mr.Countries[indexpays].debut)? indexville-1:indexville;
		                System.out.println("___Ville appui sur key -1=");
		                break;
		            case -2:
		            	indexville = (indexville < mr.Countries[indexpays].fin-1)? indexville+1:indexville;
		                System.out.println("___Ville appui sur key -2___");
		                break;
		            case -5: // valide le choix
		                System.out.println("___Ville appui sur key Entre___");
		                if (indexville==-1)	 // choix non ralis
								          {
									        System.out.println("___choix non ralis___");
							            }
										else	{
													System.out.println("___choix ralis___");
													detailSelected=true;
													}
		                break;
		        	}
				}
				repaint();
		    }
//-----------------------------------------------------------------------------
	public void keyRepeated(int key){
        detailSelected=false;
		if (viewmode==1)	// on deroule la liste des Pays 
			{
	    	switch(key){
	            case -1:
	            	indexpays-=5;
	                if (indexpays < 0)	indexpays=0;
	                //System.out.println("___appui prolong sur key -1=");
	                break;
	            case -2:
	            	indexpays+=5;
	                if (indexpays > mainroutines.NCountries-1)	indexpays=mainroutines.NCountries-1;
	                //System.out.println("___appui prolongsur key -2___");
	                break;
				}
 			}
		if (viewmode==2)	// on deroule la liste des villes
			{
	    	switch(key){
	            case -1:
	            	indexville-=5;
	                if (indexville < mr.Countries[indexpays].debut)	indexville=mr.Countries[indexpays].debut;
	                break;
	            case -2:
	            	indexville+=5;
	                if (indexville > mr.Countries[indexpays].fin-1)	indexville=mr.Countries[indexpays].fin-1;
	                break;
				}
        	}
		
		repaint();
		}
//		-----------------------------------------------------------------------------
}
