import javax.microedition.lcdui.*;

public class SalatTimeCanvas extends Canvas {
	public SalatTimeMidlet mymidlet;
	public mainroutines mr=new mainroutines(this);
	public boolean 	aboutFlag=false;
	public Image imgar, imgfr, img_compass, img_soleil, img_kaabas;
	private int width, height, width_2;
	private String version="1.6 - Janvier 2010";
	public boolean exploring=false;
	public boolean EventsAdding=false;

//-----------------------------------------------------------------------------
	public SalatTimeCanvas(SalatTimeMidlet mymidlet) {
		this.mymidlet=mymidlet;
		width = getWidth ();
		width_2 = width/2;
		height = getHeight ();
    // Construct the image from the media file
	    try {
		      imgar = Image.createImage("/mosque-ar32.png");
		      imgfr = Image.createImage("/mosque-fr32.png");
		      img_compass 	= Image.createImage("/compass.png");
		      img_kaabas 	= Image.createImage("/kaabas.png");
		      img_soleil 	= Image.createImage("/soleil.png");
	    } catch (Exception e) {
	      e.printStackTrace ();
	      imgar = null; imgfr = null; img_compass = null;
	      img_kaabas = null; img_soleil= null;
	    }
		init();
	  }
//-----------------------------------------------------------------------------
	public void init(){
		mr.init();				// celui de mainroutines
		// mr.ComputeSalatTime(); apres la lecture de la db de la ville
		mr.GetHeure();		// mettre  jour le MyTimeZone
		}
//-----------------------------------------------------------------------------
// Paint the screen based on the name
	protected void paint (Graphics g) {
		int ly=16; int lyy=8; int lyyy=6; int ligne=0; int ColHeure=105;
		g.setColor(0xffffff);
		g.fillRect(0,  0, width, height);
		g.setColor(0x000000);

		if (aboutFlag )
				{	// affiche l' "A propos"
			g.setFont(Font.getFont( Font.FACE_PROPORTIONAL, Font.STYLE_BOLD, Font.SIZE_LARGE));
				ly=g.getFont().getHeight();
				if (imgar != null) g.drawImage (imgar, width, 0, Graphics.TOP | Graphics.RIGHT);
				if (imgfr != null) g.drawImage (imgfr, 0, 0, Graphics.TOP | Graphics.LEFT);
				g.setColor(0x0000FF);
				ligne=ly;
				g.drawString ("SalatTime", width_2, ligne, Graphics.BASELINE | Graphics.HCENTER);
				
				g.setFont(Font.getFont( Font.FACE_MONOSPACE,  Font.STYLE_PLAIN, Font.SIZE_MEDIUM));
				lyy=g.getFont().getHeight();
				g.setColor(0x000000);
				ligne+=ly+lyy;
				g.drawString ("www.salat-mosque.com", width_2, ligne, Graphics.BASELINE | Graphics.HCENTER);
				ligne+=lyy;
				g.drawString ("Ecrit par :", width_2, ligne, Graphics.BASELINE | Graphics.HCENTER);
				
				g.setFont(Font.getFont( Font.FACE_PROPORTIONAL, Font.STYLE_BOLD, Font.SIZE_MEDIUM));
				g.setColor(0x0066CC);
				ligne+=lyy;
				g.drawString ("Lotfi BAGHLI", width_2, ligne, Graphics.BASELINE | Graphics.HCENTER);

				g.setFont(Font.getFont( Font.FACE_MONOSPACE,  Font.STYLE_PLAIN, Font.SIZE_MEDIUM));
				g.setColor(0x000000);
				ligne+=lyy;
				g.drawString ("Version "+version, width_2, ligne, Graphics.BASELINE | Graphics.HCENTER);		
				
				g.setFont(Font.getFont( Font.FACE_PROPORTIONAL,  Font.STYLE_PLAIN, Font.SIZE_SMALL));
				lyyy=g.getFont().getHeight();
				g.setColor(0x0066CC);
				ligne+=lyyy;
				g.drawString ("Merci de prier pour notre", width_2, ligne, Graphics.BASELINE | Graphics.HCENTER);
				ligne+=lyyy;
				g.drawString ("maghfira wa rahma", width_2, ligne, Graphics.BASELINE | Graphics.HCENTER);
				}

		if (mr.limitValid && !aboutFlag )
				{	// affiche l'invalidit de l'application
			if (imgar != null) g.drawImage (imgar, width, 0, Graphics.TOP | Graphics.RIGHT);
			if (imgfr != null) g.drawImage (imgfr, 0, 0, Graphics.TOP | Graphics.LEFT);
				g.setFont(Font.getFont( Font.FACE_PROPORTIONAL, Font.STYLE_BOLD, Font.SIZE_LARGE));
				ly=g.getFont().getHeight();
				g.setColor(0x0000FF);
				ligne=ly;
				g.drawString ("SalatTime", width_2, ligne, Graphics.BASELINE | Graphics.HCENTER);
				
				g.setFont(Font.getFont( Font.FACE_PROPORTIONAL,  Font.STYLE_PLAIN, Font.SIZE_MEDIUM));
				lyy=g.getFont().getHeight();
				g.setColor(0x000000);
				ligne+=ly+lyy;
				g.drawString ("www.salat-mosque.com", width_2, ligne, Graphics.BASELINE | Graphics.HCENTER);
				g.setColor(0xFF0000);
				ligne+=lyy;
				g.drawString ("Tlchargez la mise  jour", width_2, ligne, Graphics.BASELINE | Graphics.HCENTER);
				g.setFont(Font.getFont( Font.FACE_PROPORTIONAL,  Font.STYLE_PLAIN, Font.SIZE_SMALL));
				lyyy=g.getFont().getHeight();
				g.setColor(0x0066CC);
				ligne+=lyyy;
				g.drawString ("Merci de prier pour notre", width_2, ligne, Graphics.BASELINE | Graphics.HCENTER);
				ligne+=lyyy;
				g.drawString ("maghfira wa rahma", width_2, ligne, Graphics.BASELINE | Graphics.HCENTER);
				}
		if (mr.validSalatTimeC && !aboutFlag && !mr.limitValid)
				{	// affiche les horaires
				if (imgar != null) g.drawImage (imgar, width, 0, Graphics.TOP | Graphics.RIGHT);
				g.setFont(Font.getFont( Font.FACE_PROPORTIONAL,  Font.STYLE_BOLD, Font.SIZE_MEDIUM));
				lyy=g.getFont().getHeight();
				ColHeure=(int)(width*0.75);
				String SS;
				g.setColor(0x0099FF);
				ligne=lyy;
				g.drawString ("Fajr", 2, ligne, Graphics.BASELINE | Graphics.LEFT);
					g.drawString (mr.h2hmiarrondie(mr.SalatTimeC.Fajr), ColHeure, ligne, Graphics.BASELINE | Graphics.RIGHT);
					g.setColor(0xFFCC00);
				ligne+=lyy;
				g.drawString ("Chourouk", 2, ligne, Graphics.BASELINE | Graphics.LEFT);
					g.drawString (mr.h2hmiarrondie(mr.SalatTimeC.Chourouk), ColHeure, ligne, Graphics.BASELINE | Graphics.RIGHT);
				g.setColor(0xFF66FF);
				ligne+=lyy;
				g.drawString ("Zuhr", 2, ligne, Graphics.BASELINE | Graphics.LEFT);
					g.drawString (mr.h2hmiarrondie(mr.SalatTimeC.Zuhr), ColHeure, ligne, Graphics.BASELINE | Graphics.RIGHT);
				g.setColor(0x33FF00);
				ligne+=lyy;
				g.drawString ("Asr", 2, ligne, Graphics.BASELINE | Graphics.LEFT);
					g.drawString (mr.h2hmiarrondie(mr.SalatTimeC.Asr), ColHeure, ligne, Graphics.BASELINE | Graphics.RIGHT);
				g.setColor(0xFF0000);
				ligne+=lyy;
				g.drawString ("Maghrib", 2, ligne, Graphics.BASELINE | Graphics.LEFT);
					g.drawString (mr.h2hmiarrondie(mr.SalatTimeC.Maghrib), ColHeure, ligne, Graphics.BASELINE | Graphics.RIGHT);
				g.setColor(0x0000FF);
				ligne+=lyy;
				g.drawString ("Isha", 2, ligne, Graphics.BASELINE | Graphics.LEFT);
					g.drawString (mr.h2hmiarrondie(mr.SalatTimeC.Isha), ColHeure, ligne, Graphics.BASELINE | Graphics.RIGHT);
				
				g.setColor(0x000000);
				g.setFont(Font.getFont( Font.FACE_PROPORTIONAL,  Font.STYLE_PLAIN, Font.SIZE_MEDIUM));
				ligne+=lyy;
				g.drawString (mr.CountryName+", "+ mr.TownName+"  TZ "+mr.MyTimeZone,
								width /2, ligne, Graphics.BASELINE | Graphics.HCENTER);
				//		SS="latitude="+rd2degminsec(latitude)+"   longitude="+rd2degminsec(longitude)+" Convention "+Convention;
				SS=mr.Days[mr.CalculeJour(mr.T+(mr.MyTimeZone+12)/24.0/36525.0)]+" "+mr.date.j+"/"+mr.date.m+"/"+mr.date.a;
				if (mr.DSTApplies)	SS+="   DST";
				g.setFont(Font.getFont( Font.FACE_PROPORTIONAL,  Font.STYLE_BOLD, Font.SIZE_MEDIUM));
				ligne+=lyy-1;
				g.drawString (SS, width_2, ligne, Graphics.BASELINE | Graphics.HCENTER);
				ligne+=lyy-3;

				if (exploring)	{
								g.setFont(Font.getFont( Font.FACE_PROPORTIONAL,  Font.STYLE_BOLD, Font.SIZE_MEDIUM));
								g.setColor(0xFF0000);
								g.drawString ("Exploration de cette date", width_2, ligne, Graphics.BASELINE | Graphics.HCENTER);
								}
					else if (EventsAdding){
								g.setFont(Font.getFont( Font.FACE_PROPORTIONAL,  Font.STYLE_BOLD, Font.SIZE_MEDIUM));
								g.setColor(0xFF0000);
								g.drawString ("Ajout d'vnements...", width_2, ligne, Graphics.BASELINE | Graphics.HCENTER);
								}
					else		{
								g.setFont(Font.getFont( Font.FACE_PROPORTIONAL,  Font.STYLE_PLAIN, Font.SIZE_MEDIUM));
								if (mr.Towns[mr.TownSelected].Country>=6) 	{
										g.setColor(0xFF0000);
										g.drawString ("Horaires non vrifis", width_2, ligne, Graphics.BASELINE | Graphics.HCENTER);
										}
								else	{
										SS="";
										if (mr.heure.h<10) SS+="0";
										SS+=mr.heure.h+":";
										if (mr.heure.m<10) SS+="0";
										SS+=mr.heure.m+":";
										if (mr.heure.s<10) SS+="0";
										SS+=mr.heure.s;
										g.drawString ( SS, width_2, ligne, Graphics.BASELINE | Graphics.HCENTER);
										}

								}
				}
		}

//-----------------------------------------------------------------------------
	public void TimerCheck(){
		if (EventsAdding || exploring || aboutFlag || mr.limitValid)	return;
		mr.GetDate();
		mr.GetHeure();
		if (mr.LastComputeDate.a!=mr.date.a || mr.LastComputeDate.m!=mr.date.m || mr.LastComputeDate.j!=mr.date.j)			
			{
			mr.ComputeSalatTime();
			}
		repaint();
	}
}
